//   Read a Brookhave Protien Datatbase (.pdb) File
//   Written By Sean Moyer (Copywrite 1998)
//   This program is the intellectual property of Sean Moyer,
//   and may not be redistributed for commercial gain without
//   his express permission.
//   Updated by Art Howe and Arnie Cachelin 8/01
//   Updated by Peter Inkpen 24/02/2002
//   Updated by Alexandre Labedade 25/02/2002
//   Updated by Alexandre Labedade 29/03/2003
//   Updated by Sean Moyer 02/04/2003

@warnings
@version 2.5

var c1,e6,e62,cr1,cr2,fg,c5;
var pLinkResolution;
var currentVersion;

main
{

    fg = lyrfg();
    fg = fg[1];
    
    currentVersion = lscriptVersion();
    currentVersion = currentVersion[1].asNum();

    xhi = 0.0;
    xlo = 0.0;
    yhi = 0.0;
    ylo = 0.0;
    zhi = 0.0;
    zlo = 0.0;

    objDir = getdir("Objects");

    sceneFileName = getfile("Load PDB File","*.txt;*.pdb;*.ent",objDir,true);

    if(sceneFileName == nil)
    return;

    sceneFile = File(sceneFileName,"r");

    if(sceneFile == nil)
    {
        error("Cannot open scene file \"",sceneFileName,"\"");
        return;
    }

    filePath = split(sceneFileName);        

    var lineCount = sceneFile.linecount();

var loopcount=0;

//_____________________________________________Prescan for ATOM/HETATM Differences
    atomcount = 0;
    hetcount = 0;
    connectcount = 0;

    for(j=1;j<=lineCount;++j)
    {

        sceneFile.line(j);
        var pdbarray = sceneFile.parse(" ");
        if(pdbarray[1] == "ATOM")
        {
            sceneFile.line(j);

            if(atomcount < 1)
            {
                tempatom = sceneFile.read();
                tempatomfield = size(pdbarray);
            }

            ++atomcount;
        }


        if(pdbarray[1] == "HETATM")
        {
            sceneFile.line(j);

            if(hetcount < 1)
            {
                temphet = sceneFile.read();
                temphetfield = size(pdbarray);
            }

            ++hetcount;
        }

        if(pdbarray[1] == "CONECT")
        {
            sceneFile.line(j);

            if(connectcount < 1)
            {
                tempconnect = sceneFile.read();
                tempconnectfield = size(pdbarray);
            }

            ++connectcount;
        }


    }

//___________________________________Prep Requestor

    if(tempatom == nil && temphet == nil)
    {
        error("<br>No ATOM or HETATM data found. Your file may be corrupt.");
        return;
    }
    
    var connectID = array;
    var connectPOS = array;
    
    xfield = 7;
    yfield = 8;
    zfield = 9;
    atomfield = 3;
    
    hxfield = 7;
    hyfield = 8;
    hzfield = 9;
    hetfield = 3;   
    
    
    var cr1 = globalrecall("PDBREADER_cr1",true);
    var cr2 = globalrecall("PDBREADER_cr2",true);

    var relscale = globalrecall("PDBREADER_relscale",1.0);
    var tess = globalrecall("PDBREADER_tess",1);
    var step = globalrecall("PDBREADER_step",1);
    var sides = globalrecall("PDBREADER_sides",8);
    var adaptivetess = globalrecall("PDBREADER_adaptivetess",true);
    var pDrawMode = globalrecall("PDBREADER_pDrawMode",1);
    var pSplitMode = globalrecall("PDBREADER_pSplitMode",1);
    
    var pAddLink = globalrecall("PDBREADER_pAddLink",0);

    var pScaleDown = globalrecall("PDBREADER_pScaleDown",1);
    var pLinkResolution = globalrecall("PDBREADER_pLinkResolution",3);
    var pSetColors = globalrecall("PDBREADER_pSetColors",true);

//_______________________Added 02/04/2003

    var skipHydrogen = globalrecall("PDBREADER_skipHydrogen",false);
    var groupColor = globalrecall("PDBREADER_groupColor",FALSE);
    var stickScale = globalrecall("PDBREADER_stickScale",1.0);

//_______________________Add Ends

    
    mkstandard=false;
    
    splitlayers = true;
    splitgroup=false;
    splitperiod=false;

    boxmode = false;
    hvmode=false;
    
    
    atstr = string(atomcount,"  ATOM Entries");
    htstr = string(hetcount,"  HET Entries");
    ttstr = string((atomcount+hetcount)," Combined Entries");
    cnctstr = string(connectcount,"  CONECT Entries");

    bigstr = string(atstr,"  -  ",htstr,"  -  ",ttstr,"  -  ",cnctstr);

    atfieldstr = string("Sample ATOM Line: ",tempatomfield," Fields");
    htfieldstr = string("Sample HET Line: ",temphetfield," Fields");


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//         Beginning of User Interface
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    
    reqbegin("Sean's & Alexx's PDB Reader");
    reqsize(650,630);
    
    d0=ctltext("",bigstr);
    ctlposition(d0,80,5,300,20);
    
    YPOS = 35;

//____________________________________________________________Display/Choose ATOM FIELDS

    if(atomcount != 0)
    {
       // d1=ctltext("",atfieldstr);
       // ctlposition(d1,5,25,200,20);
        
        lst = parse(" ",tempatom);
        e4 = ctlchoice("Field to read ATOM info",atomfield,lst);
        ctlposition(e4,5,YPOS,520,20);
        
        cr1 = ctlcheckbox ("Create ATOM",true);
        ctlposition(cr1,530,YPOS,100,20);
        YPOS += 30;

        c9 = ctlchoice("Field to read as Protien Group",atomfield,lst);
        ctlposition(c9,5,YPOS,520,20);

        cr3 = ctlcheckbox ("Use Group Color",groupColor.asInt());
        ctlposition(cr3,530,YPOS,100,20);


        
        // searching for x field
        first=xfield;
        for(j=1;j<size(lst);j++){
            var uu=parse(".",lst[j]);
            if (size(uu)>1){
                first=j;
                break;
            }
        }
        xfiled=first;
        yfield=first+1;
        zfield=first+2;
        
        YPOS += 30;
    }
    else{

    x1=ctltext("","No ATOM Entries Found.");
    ctlposition(x1,5,YPOS,150,20);
    YPOS += 30;

    x2=ctltext("","No Protien Group Information Available.");
    ctlposition(x2,5,YPOS,150,20);
    YPOS += 30;

    }
//________________________________________________________________Display/Choose HET FIELDS

    
    if(hetcount != 0)
    {
      //  d2=ctltext("",htfieldstr);
      //  ctlposition(d2,210,25,200,20);
        
        lst = parse(" ",temphet);
        f4 = ctlchoice("Field to read HET info   ",hetfield,lst);
        ctlposition(f4,5,YPOS,520,20);
        
        cr2 = ctlcheckbox ("Create HET",true);
        ctlposition(cr2,530,YPOS,100,20);
        
        // searching for x field
        first=hxfield;
        for(j=1;j<size(lst);j++){
            var uu=parse(".",lst[j]);
            if (size(uu)>1){
                first=j;
                break;
            }
        }
        hxfiled=first;
        hyfield=first+1;
        hzfield=first+2;
        
        YPOS += 30;
    }
    else{

    x3=ctltext("","No HETATOM Entries Found.");
    ctlposition(x3,5,YPOS,150,20);
    YPOS += 30;

    }



//__________________________________________________________________Main User Settings

 

    //_______________________________Scale Options
   
    s1 = ctlsep();
    ctlposition(s1,5,YPOS,640,2);
    YPOS += 10;
    
    d3=ctltext("","Scale Options :");
    ctlposition(d3,5,YPOS,150,20);
    YPOS += 20;


    
    e5 = ctlnumber("Atom Scale",relscale.asNum());
    ctlposition(e5,80,YPOS,130,20);

    c10 = ctlnumber("Stick Scale",stickScale.asNum());
    ctlposition(c10,220,YPOS,130,20);

    c4 = ctlchoice("Scale Down Mode",pScaleDown.asInt(),@"None","50%","Monoscale"@);
    ctlposition(c4,360,YPOS,250,20);


    YPOS += 30;


//______________________________________Construction Options

    s2 = ctlsep();
    ctlposition(s2,5,YPOS,640,2);
    YPOS += 10;
    
    d4=ctltext("","Display Options :");
    ctlposition(d4,5,YPOS,150,20);
    YPOS += 27;  

    

    
    c1 = ctlchoice("Create",pDrawMode.asInt(),@"Tesselated Sphere","Segmented Sphere","Boxes","HV Particles","Text"@,true);
    ctlposition(c1,43,YPOS,200,80);
    
    e6 = ctlslider("Sphere Tesselation Level",tess.asNum(),1,4);
    ctlposition(e6,260,YPOS,150,20);
    ctlrefresh(e6,"limittess");
    YPOS += 20;


    e62 = ctlslider("Standard Sphere Sides Level",sides.asInt(),4,32);
    ctlposition(e62,260,YPOS,180,20);
        YPOS += 40; 

    e70 = ctlchoice("Display Axis",displayMode.asInt(),@"X","Y","Z"@);
    ctlposition(e70,260,YPOS,180,20);

        YPOS += 30; 

    e8 = ctlcheckbox ("Adaptive Tesselation/Sides (override Sphere Tess or Sides Level)",adaptivetess.asInt());
    ctlposition(e8,80,YPOS,350,20);


    ctlrefresh(e62,"limitseg");
    
    
    ctlvisible(c1,"vis1",e6);
    ctlvisible(c1,"vis2",e62);

    ctlvisible(c1,"vis3",e8);

    ctlvisible(c1,"vis4",e70);

    YPOS += 30;

 // OLD     c3 = ctlcheckbox("Add Sticks",pAddLink.asInt());

    c3 = ctlchoice("Sticks",pAddLink.asInt(),@"   None","From CONECT","Generate"@);
    ctlposition(c3,80,YPOS,230,20);
    
    c5 = ctlslider("Stick Resolution",pLinkResolution.asInt(),1,12);
    ctlposition(c5,320,YPOS,200,20);
    
    YPOS += 30;

    c7 = ctlcheckbox("Skip Hydrogen",skipHydrogen.asInt());
    ctlposition(c7,80,YPOS,200,20);

    YPOS += 30;

    // colors only for lscript 2.6 and >
    if(currentVersion>2.6){
        c6 = ctlcheckbox("Set CPK/Shapely Colors",pSetColors.asInt());
        ctlposition(c6,80,YPOS,210,20);
    YPOS += 30;
    }
        else{

        x4=ctltext("","Surface Color Assignment awaits release of LScript 2.6.1, please use Template Object workaround.");
        ctlposition(x4,80,YPOS,200,20);
        YPOS += 30;

        }
//____________________________________________Organization Options

    s3 = ctlsep();
    ctlposition(s3,5,YPOS,640,2);
    YPOS += 10;
    
    d5=ctltext("","Organization Options :");
    ctlposition(d5,5,YPOS,150,20);
    YPOS += 27;  


    c2 = ctlchoice("Split by",pSplitMode.asInt(),@"None","Atomic Numbers [ Layers 1 - 72 ]  [ 100 for Unknown ]","Atomic Group     [ Layers 1 - 18 ]  [ 20 for Unknown ]","Period                [ Layers 1 - 6 ]    [ 10 for Unknown ]  ( Period = Electron Count )","Protien Group     [ Layers 1 - 41 ]  [ 50 for Unknown ]"@,true);
    ctlposition(c2,40,YPOS,550,80);





    YPOS += 90;
    
    log1 = ctlcheckbox ("Save Log File :",keeplog.asInt());
        ctlposition(log1,80,YPOS,100,20);
   


    if(reqpost())
    {
        
        if(atomcount != 0)
        {
            atomfield = getvalue(e4);
            cr1=getvalue(cr1).asInt();
            protienGroup = getvalue(c9);
            groupColor=getvalue(cr3);   
        }else{
            groupColor = false;
            
        }
        
        if(hetcount != 0)
        {
            hetfield = getvalue(f4);
            cr2=getvalue(cr2).asInt();
        }
        relscale = getvalue(e5);

        stickScale = getvalue(c10);
        
        pDrawMode = getvalue(c1);
        
        tess = getvalue(e6);
        
        adaptivetess = getvalue(e8);
        //boxmode = getvalue(e9);
        //hvmode = getvalue(e10);
        
        pSplitMode = getvalue(c2);
        
        splitlayers = (pSplitMode == 2);
        splitgroup = (pSplitMode == 3);
        splitperiod = (pSplitMode == 4);
        splitprotien = (pSplitMode == 5);
        
        //mkstandard = getvalue(e61);
        
        mkstandard = false;
        if(pDrawMode==2) mkstandard = true;
        sides = getvalue(e62);
        
        boxmode = false;
        if(pDrawMode==3) boxmode = true;
        
        hvmode = false;
        if(pDrawMode==4) hvmode = true;
        
        pAddLink = getvalue(c3);
        pScaleDown = getvalue(c4);
        pLinkResolution = getvalue(c5);
        
        ratio = 1.0;
        if(pScaleDown == 2) ratio=0.5;
        
        if(hvmode){
            tess = 0;
            splitlayers = true;
        }
        
        if (atomcount==0) cr1=false;
        if (hetcount==0) cr2=false;
        
        // colors only for lscript 2.6 and >

        if(currentVersion>2.6){
            pSetColors = getvalue(c6);
        }else{
            pSetColors = false;
        }

        skipHydrogen = getvalue(c7);

    displayAxis = getvalue(e70);

    keeplog = getvalue(log1);


    }
       
    else
        return;
    reqend;


    globalstore("PDBREADER_cr1",cr1);
    globalstore("PDBREADER_cr2",cr2);
    globalstore("PDBREADER_relscale",relscale);
    globalstore("PDBREADER_tess",tess);
    globalstore("PDBREADER_step",step);
    globalstore("PDBREADER_sides",sides);
    globalstore("PDBREADER_adaptivetess",adaptivetess);
    globalstore("PDBREADER_pDrawMode",pDrawMode);
    globalstore("PDBREADER_pSplitMode",pSplitMode);
    
    globalstore("PDBREADER_pAddLink",pAddLink);

    globalstore("PDBREADER_pScaleDown",pScaleDown);
    globalstore("PDBREADER_pLinkResolution",pLinkResolution);
    globalstore("PDBREADER_pSetColors",pSetColors);

//________________Added 02/04/03

    globalstore("PDBREADER_skipHydrogen",skipHydrogen);
    globalstore("PDBREADER_groupColor",groupColor.asInt());
    globalstore("PDBREADER_stickScale",stickScale);

//________________Add Ends

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//________________________End of User Interface_____________________________________________________
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


//_____________________________Normalize Scale Values for Ball & Stick

        relscale = relscale/2.5;
    radius = stickScale/5.5;


//__________Log File______________________________

    if(keeplog == 1){

        initName = filePath[3] + ".txt";

        logFileName = getfile("Save Log File",initName,objDir,true);

        if(logFileName == nil)
        return;

        logFile = File(logFileName,"wa");

        if(logFile == nil)
        {
            error("Cannot Open Log File \"",logFileName,"\"");
            return;
        }
    }



    monstr = string("Creating ",((atomcount*cr1.asNum())+(hetcount*cr2.asNum()))," Entries");

    monsize = integer((lineCount/step.asNum()))+10;
    
    moninit(monsize,monstr);



    minscale=999999;
    /*
    surfacelist=array;
    
    n=1;
    srf=Surface(n);
    while(srf)
    {
        surfalcelist += srf;
        n++;
        srf=Surface(n);
    }
    */


    logarray[lineCount] = nil;

    linkslst = array;

//_____________For Generate Links: Initialize Array

    if(pAddLink == 3){
        vectorArray[lineCount] = nil;
    }
    


//___________________________________________________Start Main Loop_____________________________


        for(i=1;i<=lineCount;++i)
        {

            sceneFile.line(i);
            var pdbarray = sceneFile.parse(" ");
            
            
/*           // sort links
            if(pAddLink && (pdbarray[1] == "CONECT")){
                
                
            
            }
*/
            

            testlink=((pAddLink == 2) && (pdbarray[1] == "CONECT"));
            selmode(USER);
            
            if(pdbarray[1] == "ATOM" || pdbarray[1] == "HETATM" || testlink)
            {

                thescale = 1.0;
                //setsurface("ATOM_Unknown");
            if(!testlink){
//____________________________________________________________Look for Number Before Atom Designation

            StartPos = 1;
            if(pdbarray[1] == "ATOM")
            {
                thepoint = vector(string(pdbarray[xfield]," ",pdbarray[yfield]," ",pdbarray[zfield]));
                
                Chars = size(pdbarray[atomfield]);

                atomtype = strleft(pdbarray[atomfield],StartPos);

                // Remove first character if it is a number             
                if(number(atomtype) != nil)
                {
                    Chars = Chars - 1;
                    StartPos = 2;
                }

                atomtype = strsub(pdbarray[atomfield],StartPos,Chars);      

            // Chop of Garbage on the Right
        if(size(atomtype) > 2){
            atomtype = strsub(atomtype,1,2);
        }             

            // Discard second letter value if it is a CAPITAL

        if(size(atomtype) == 2){
            if(ascii(strsub(atomtype,2,1)) < 97){
            atomtype = strsub(atomtype,1,1);
            }
        }           
            }




           
            if(pdbarray[1] == "HETATM"){
                thepoint = vector(string(pdbarray[hxfield]," ",pdbarray[hyfield]," ",pdbarray[hzfield]));

                Chars = size(pdbarray[hetfield]);

                atomtype = strleft(pdbarray[hetfield],StartPos);

                if(number(atomtype) != nil)
                {
                    Chars = Chars - 1;
                    StartPos = 2;
                }
                
                atomtype = strsub(pdbarray[atomfield],StartPos,Chars);

            // Chop of Garbage on the Right
        if(size(atomtype) > 2){
            atomtype = strsub(atomtype,1,2);
        }             

            // Discard second letter value if it is a CAPITAL

        if(size(atomtype) == 2){
            if(ascii(strsub(atomtype,2,1)) < 97){
            atomtype = strsub(atomtype,1,1);
            }
        } 



            }


//_____________For Connection Log & Generate

        atomIndex = integer(pdbarray[2]);
        logarray[atomIndex] = atomtype;


    

//_____________________________________________________________________________Assign Size & Surface

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//         Prefix for surfaces
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if(pdbarray[1] == "ATOM"){
            prefix = "ATOM_";
        }else{
            prefix = "HET_";
        }
        
        if(groupColor) prefix = "GROUP_";


            
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

              
                // Culled a variety of Inorganics, resurfaced a variety of metals as _Metal
                // To conform with the CPK standards used by most PDB molecular modelers
                // source : http://www.webelements.com/
                
                TheGroup=0; // = col in the periodic tbale of elements
                ThePeriod=0;    // = row in the periodic tbale of elements (= electrons count)
                skipFlag = 0;   // We'll set this Flag to 1 is we find a Hydrogen Atom & Skip Hydrogen is True

       
 // Re-sorted to bias most common elements to top of selection
                
                select 

//________________Most Common_________________


                when atomtype == "C" then do
                    thescale = 1.5;
                    setsurface(prefix+"Carbon");


                    TheLayer = 1;
                    TheGroup=14;
                    ThePeriod=2;
                    end

                when atomtype == "H" then do
                    thescale = 1.0;
                    setsurface(prefix+"Hydrogen");
                    TheLayer = 2;
                    TheGroup=1;
                    ThePeriod=1;
                    if(skipHydrogen == 1){
                        skipFlag = 1;
                    }
                    end

                when atomtype == "O" then do
                    thescale = 1.3;
                    setsurface(prefix+"Oxygen");
                    TheLayer = 3;
                    TheGroup=16;
                    ThePeriod=2;
                    end

                when atomtype == "N" then do
                    thescale = 1.4;
                    setsurface(prefix+"Nitrogen");
                    TheLayer = 4;
                    TheGroup=15;
                    ThePeriod=2;
                    end                


//________________Less Common_________________


                when atomtype == "P" then do
                    thescale = 1.2;
                    setsurface(prefix+"Phosphorus");
                    TheLayer = 6;
                    TheGroup=15;
                    ThePeriod=3;
                    end
    
                when atomtype == "S" then do
                    thescale = 1.9;
                    setsurface(prefix+"Sulphur");
                    TheLayer = 7;
                    TheGroup=16;
                    ThePeriod=3;
                    end

                when atomtype == "Fe" then do
                    thescale = 1.5;
                    setsurface(prefix+"Iron");
                    TheLayer = 8;
                    TheGroup=8;
                    ThePeriod=4;
                    end  

              when atomtype == "Ca" then do
                    thescale = 1.5;
                    setsurface(prefix+"Calcium");
                    TheLayer = 9;
                    TheGroup=2;
                    ThePeriod=4;
                    end

                when atomtype == "Cl" then do
                    thescale = 1.5;
                    setsurface(prefix+"Chlorine");
                    TheLayer = 10;
                    TheGroup=17;
                    ThePeriod=3;
                    end

                when atomtype == "F" then do
                    thescale = 1.5;
                    setsurface(prefix+"Fluorine");
                    TheLayer = 11;
                    TheGroup=17;
                    ThePeriod=2;
                    end

                when atomtype == "Br" then do
                    thescale = 1.5;
                    setsurface(prefix+"Bromine");
                    TheLayer = 12;
                    TheGroup=17;
                    ThePeriod=4;
                    end

                when atomtype == "Zn" then do
                    thescale = 1.5;
                    setsurface(prefix+"Zinc");
                    TheLayer = 13;
                    TheGroup=12;
                    ThePeriod=4;
                    end  
                
                when atomtype == "I" then do
                    thescale = 1.5;
                    setsurface(prefix+"Iodine");
                    TheLayer = 14;
                    TheGroup=17;
                    ThePeriod=5;
                    end

                when atomtype == "Na" then do
                    thescale = 1.5;
                    setsurface(prefix+"Sodium");
                    TheLayer = 5;
                    TheGroup=1;
                    ThePeriod=3;
                    end
                

//________________Rare__________________________


                when atomtype == "Co" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=9;
                    ThePeriod=4;
                    end 

                when atomtype == "Li" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=1;
                    ThePeriod=2;
                    end

                when atomtype == "Be" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=2;
                    ThePeriod=2;
                    end

                when atomtype == "Mg" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=2;
                    ThePeriod=3;
                    end

                when atomtype == "Al" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=13;
                    ThePeriod=3;
                    end
               
                when atomtype == "K" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=1;
                    ThePeriod=4;
                    end
                               
                when atomtype == "Sc" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=3;
                    ThePeriod=4;
                    end                        
                
                when atomtype == "Cr" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=6;
                    ThePeriod=4;
                    end   
                
                when atomtype == "Mn" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=7;
                    ThePeriod=4;
                    end   
                
                when atomtype == "Ni" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=10;
                    ThePeriod=4;
                    end  
                
                when atomtype == "Cu" then do
                    thescale = 1.5;
                    setsurface(prefix+"Metal");
                    TheLayer = 15;
                    TheGroup=11;
                    ThePeriod=4;
                    end  
                
//_______________Unknown______________________________

            
    
        otherwise do
                    thescale = 1.5;
                    setsurface(prefix+"Unknown");
                    catcher = pdbarray[atomfield];
                    catchstr = string(atomtype," Unable to Indentify ",catcher);
                    TheLayer = 14;
                    TheGroup=20;
                    ThePeriod=10;

            if(keeplog == 1){

                logFile.write(",,,");
                logFile.writeln(catchstr);
            }



                end

            end // End select

            if(atomcount != 0)
            {
            groupType = pdbarray[protienGroup];

            if(groupColor == TRUE)
                setsurface(prefix+groupType);
        }
        





//____________________________________________________________________________________________Layer_Splitting


            
            if(splitlayers) lyrsetfg(TheLayer); // Select the layer associated with the type of atom.

            if(splitgroup){
                lyrsetfg(TheGroup); // Select the layer associated with the group of atom.
                setlayername(atomtype);
            }

            if(splitperiod){
                lyrsetfg(ThePeriod); // Select the layer associated with the period of atom.
                setlayername(atomtype);
            }


            if(splitprotien){
                groupType = pdbarray[protienGroup]; 
                lyrsetfg(protienid(groupType));    //  See protienid function at end of the code
                setlayername(groupType);
            }




                thescale = (thescale * relscale);
                
                var create=true;
                
                if(pdbarray[1] == "ATOM"){
                    
                    // search for first float value in ATOM Line
                    connectID += pdbarray[2].asInt();
                    
                    first=xfield;
                    for(j=1;j<size(pdbarray);j++){
                        var uu=parse(".",pdbarray[j]);
                        if (size(uu)>1){
                            first=j;
                            break;
                        }
                    }
                    
                    thepoint = vector(string(pdbarray[first]," ",pdbarray[first + 1]," ",pdbarray[first + 2]));
                    
                    connectPOS += thepoint.asVec();
                    
                    create=cr1;
                }

                if(pdbarray[1] == "HETATM"){
                    
                    connectID += pdbarray[2].asInt();
                    
                    // search for first float value HET line

                    first=hxfield;
                    for(j=1;j<size(pdbarray);j++){
                        var uu=parse(".",pdbarray[j]);
                        if (size(uu)>1){
                            first=j;
                            break;
                        }
                    }
    
                    thepoint = vector(string(pdbarray[first]," ",pdbarray[first + 1]," ",pdbarray[first + 2]));
                    
                    connectPOS += thepoint.asVec();
                    
                    create=cr2;
                }


            if(skipFlag == 1){
            create = FALSE;
            }




//_______________________________________For Generate Links

    if(pAddLink == 3){
        vectorArray[atomIndex] = thepoint;
        
        sortArray = vectorArray[atomIndex].asVec();

        testx = sortArray.x;
        testy = sortArray.y;
        testz = sortArray.z;

        if(testx > xhi) xhi = testx;
        if(testx < xlo) xlo = testx;

        if(testy > yhi) yhi = testy;
        if(testy < ylo) ylo = testy;

        if(testz > zhi) zhi = testz;
        if(testz < zlo) zlo = testz;

    }


//__________________________________________________________Make Some Geometry


                if(create!=false && pdbarray[1] != "CONECT"){

        if(pDrawMode == 4){
                    if(tess == 0)
                    {
                        // HV Mode
                        editbegin();
                        pntid = addpoint(thepoint);
                        addpolygon(pntid);
                        editend();
                    }
        }

                    
        if(pDrawMode == 3){                 
                        if(boxmode){
                            ts = (thescale / 2.0)*2.1;
                            
                            if(pScaleDown == 2){
                                ts *= ratio;
                            }else if(pScaleDown == 3){
                                ts = (relscale / 3.0) * ratio;
                            }
                            
                            if(ts<minscale) minscale = ts;
                            
                            c1 = thepoint - vector(string(ts," ",ts," ",ts));
                            c2 = thepoint + vector(string(ts," ",ts," ",ts));
                        
                            makebox(c1,c2);

                        }
        }


        if(pDrawMode <=2){              
                            if(adaptivetess && pScaleDown!=3){
                                tt=1;
                                if(thescale>0.8) tt=2;
                                if(thescale>2) tt=3;
                                
                                sd=6;
                                if(thescale>=0.5) sd=8;
                                if(thescale>=0.75) sd=12;
                                if(thescale>=1) sd=16;
                                if(thescale>=1.25) sd=20;
                                                                
                            }else{
                                tt = tess;
                                sd = sides;
                            }
                            
                            if(pScaleDown == 2){
                                thescale *= ratio;
                            }else if(pScaleDown == 3){
                                thescale = (relscale / 3.0) * ratio;
                            }
                            
                            
                            
                            if(mkstandard){
                                
                                if (sd<3) sd=3;
                                sg = sd/2;
                                if (sg<2) sg=2;
                                
                                makeball(thescale,sd,sg,thepoint);
                                
                                if(sd<minscale) minscale = sd;
                                
                            }else{
                                maketesball(thescale,tt,thepoint);

                                if(tt<minscale) minscale = tt;}
                             }



                            if(pDrawMode == 5){

                                fontScale = thescale;
                                maketext(atomtype,1,SHARP,0,fontScale,displayAxis,thepoint);
                            }                                   
            }
        }


        //Optimize Speed by Hiding Geometry as Created
        selhide(SELECTED);


//________________________________________________________________________________________Make Links


    
                if(pdbarray[1] == "CONECT" && pdbarray.count()>2){
                    setsurface("LINKS");
                    
                    if(pLinkResolution>0){
                    
                        editbegin();
                        id1 = pdbarray[2].asInt();
                        for(j=3;j<=pdbarray.count();j++){
                            
                            if(monstep())
                                {       
                                lyrsetfg(fg);
                                lyrsetbg(bg);
                                editend(ABORT);
                                return;
                                }
                            
                            id2 = pdbarray[j].asInt();
    
                            // the lines that starts with CONECT are like this :
                            // CONECT x a b c d e
                            // meaning : atom x has connection with atoms a,b,c,d and e
                            // here the last test id1>id2 prevent from the double creation of links
                            
                            if(id1>0 && id1<=connectID.count() && id2>0 && id2<=connectID.count() && id1>id2){
                                
                                if(pLinkResolution==1){
                                    // create a 2d line
                                    pnt = array;
                                    pnt += addpoint(connectPOS[id1]);
                                    pnt += addpoint(connectPOS[id2]);
                                    
                                    addpolygon(pnt);

//_________________________________________________________Connection Log

                        if(keeplog == 1){
                            logFile.write("Linked : ");         
                            logFile.write(logarray[id1]);
                            logFile.write(", ");

                            logFile.write(logarray[id2]);
                            logFile.write(", ");
                        }



                                }else{
                                    // create a cylinder or a box
                                    pnt = array;
                                    pnt += connectPOS[id2];
                                    pnt += connectPOS[id1];

                                bondLen = addlink(pnt,radius,pLinkResolution,pDrawMode); // see addlink function at the end of the code



//______________________________________________________________Connection Log

                        if(keeplog == 1){
                            // logFile.write("Linked : ");      
                            logFile.write(logarray[id1]);
                            logFile.write(", ");

                            logFile.write(logarray[id2]);
                            logFile.write(", ");

                            // logFile.write("Bond Length = ");
                            logFile.writeln(bondLen);
                    }
                                } 
                            }
                        }
                        editend();
                    }
                }



                                
                
                if(monstep())
                {       
                    lyrsetfg(fg);
                    lyrsetbg(bg);
                    editend(ABORT);
                    return;
                }
            }
        }
    
    monend();


    
    lyrsetfg(98);
    selunhide();
    cut();
    lyrsetfg(fg);
    paste();
        
    
    
//________________________________________________________________________________________SETTING ATOMS COLORS

    if(pSetColors){
        if(currentVersion<=2.6){
            error("You need Lscript 2.6.1 to set colors. Please use Template workaround.");
        }else{  
            n=1;
            srf=Surface(n);
            while(srf)
            {
                splt = parse("_",srf.name);
                
                if(splt.count()>1){
                    if(splt[1]=="ATOM" || splt[1]=="HET"){
                        if (splt[2] == "Unknown"){
                            srf.setValue(SURFCOLR,<255,20,147>);
                        }
                    
                        if (splt[2] == "Hydrogen"){
                            srf.setValue(SURFCOLR,<255,255,255>);
                        }
                        if (splt[2] == "Carbon"){
                            srf.setValue(SURFCOLR,<200,200,200>);
                        }
                        if (splt[2] == "Oxygen"){
                            srf.setValue(SURFCOLR,<240,0,0>);
                        }
                        if (splt[2] == "Nitrogen"){
                            srf.setValue(SURFCOLR,<143,143,255>);
                        }
                        if (splt[2] == "Sulfur"){
                            srf.setValue(SURFCOLR,<255,200,50>);
                        }
                        if (splt[2] == "Phosphorus"){
                            srf.setValue(SURFCOLR,<255,165,0>);
                        }
                        if (splt[2] == "Chlorine"){
                            srf.setValue(SURFCOLR,<0,255,0>);
                        }
                        if (splt[2] == "Bromine"){
                            srf.setValue(SURFCOLR,<165,42,42>);
                        }
                        if (splt[2] == "Sodium"){
                            srf.setValue(SURFCOLR,<0,0,255>);
                        }
                        if (splt[2] == "Iron"){
                            srf.setValue(SURFCOLR,<255,165,0>);
                        }
                        if (splt[2] == "Calcium"){
                            srf.setValue(SURFCOLR,<128,128,128>);
                        }
                        if (splt[2] == "Fluorine"){
                            srf.setValue(SURFCOLR,<0,200,255>);
                        }
                        if (splt[2] == "Metal"){
                            srf.setValue(SURFCOLR,<128,128,124>);
                        }                        
                    }


                    if(splt[1]=="GROUP" ){

                            if (splt[2] == "UNK"){
                                srf.setValue(SURFCOLR,<255,20,147>);
                            }
                            if (splt[2] == "ALA"){
                                srf.setValue(SURFCOLR,<200,200,200>);
                            }
                            if (splt[2] == "ARG"){
                                srf.setValue(SURFCOLR,<20,90,255>);
                            }
                            if (splt[2] == "ASN"){
                                srf.setValue(SURFCOLR,<0,220,220>);
                            }
                            if (splt[2] == "ASP"){
                                srf.setValue(SURFCOLR,<230,10,10>);
                            }
                            if (splt[2] == "ASX"){
                                srf.setValue(SURFCOLR,<255,0,255>); // Need Color reference
                            }
                            if (splt[2] == "CYS"){
                                srf.setValue(SURFCOLR,<230,230,0>);
                            }
                            if (splt[2] == "GLN"){
                                srf.setValue(SURFCOLR,<0,220,220>);
                            }
                            if (splt[2] == "GLU"){
                                srf.setValue(SURFCOLR,<230,10,10>);
                            }
                            if (splt[2] == "GLX"){
                                srf.setValue(SURFCOLR,<255,0,255>); // Need Color reference
                            }
                            if (splt[2] == "GLY"){
                                srf.setValue(SURFCOLR,<235,235,235>);
                            }
                            if (splt[2] == "HIS"){
                                srf.setValue(SURFCOLR,<130,130,210>);
                            }
                            if (splt[2] == "ILE"){
                                srf.setValue(SURFCOLR,<15,130,15>);
                            }
                            if (splt[2] == "LEU"){
                                srf.setValue(SURFCOLR,<115,130,15>);
                            }                        
                            if (splt[2] == "LYS"){
                                srf.setValue(SURFCOLR,<20,90,255>);
                            }
                            if (splt[2] == "MET"){
                                srf.setValue(SURFCOLR,<230,230,0>);
                            }
                            if (splt[2] == "PHE"){
                                srf.setValue(SURFCOLR,<50,50,170>);
                            }
                            if (splt[2] == "PRO"){
                                srf.setValue(SURFCOLR,<220,150,130>);
                            }
                            if (splt[2] == "SER"){
                                srf.setValue(SURFCOLR,<250,150,0>);
                            }
                            if (splt[2] == "THR"){
                                srf.setValue(SURFCOLR,<250,150,0>);
                            }
                            if (splt[2] == "TRP"){
                                srf.setValue(SURFCOLR,<180,90,180>);
                            }
                            if (splt[2] == "TYR"){
                                srf.setValue(SURFCOLR,<50,50,170>);
                            }
                            if (splt[2] == "VAL"){
                                srf.setValue(SURFCOLR,<15,130,15>);
                            }

                            // Abbreviated
                            // Overlaps with Nucleic Acids

                            // Base Pairs

                            if (splt[2] == "A"){
                                srf.setValue(SURFCOLR,<160,160,255>);
                            }
                            if (splt[2] == "+A"){
                                srf.setValue(SURFCOLR,<160,160,255>);
                            }
                            if (splt[2] == "C"){
                                srf.setValue(SURFCOLR,<255,140,75>);
                            }
                            if (splt[2] == "+C"){
                                srf.setValue(SURFCOLR,<255,140,75>);
                            }
                            if (splt[2] == "G"){
                                srf.setValue(SURFCOLR,<255,112,112>); 
                            }
                            if (splt[2] == "+G"){
                                srf.setValue(SURFCOLR,<255,112,112>);
                            }
                            if (splt[2] == "I"){
                                srf.setValue(SURFCOLR,<255,0,255>);
                            }
                            if (splt[2] == "+I"){
                                srf.setValue(SURFCOLR,<255,0,255>);
                            }
                            if (splt[2] == "T"){
                                srf.setValue(SURFCOLR,<160,255,160>); 
                            }
                            if (splt[2] == "+T"){
                                srf.setValue(SURFCOLR,<160,255,160>);
                            }
                            if (splt[2] == "U"){
                                srf.setValue(SURFCOLR,<184,184,184>);
                            }
                            if (splt[2] == "+U"){
                                srf.setValue(SURFCOLR,<184,184,184>);
                            }
                        }
                    }
                
                n++;
                srf=Surface(n);
            }
        }
    }




lyrfg=lyrdata();
lyrsetfg(lyrfg);


//__________________________________________________________________________Generate Links__(Post Main Loop)

if(pAddLink == 3){

    setsurface("LINKS");



// Begin Scan

    loosen = 1.05;

    bondMax = (2.1547 * loosen);

    xCubes = ceil((xhi-xlo)/bondMax);  //Calculate the # of cubes to divide atoms into for search
    yCubes = ceil((yhi-ylo)/bondMax);
    zCubes = ceil((zhi-zlo)/bondMax);

    simpleSize = yCubes * zCubes;

    maxAddress = xCubes * yCubes * zCubes;   

    var addressNums[maxAddress];

    for(placeAtom = 1; placeAtom <= atomIndex; ++placeAtom){   //Adds each Atom to a Box

        tempPoint = vectorArray[placeAtom].asVec();

            tempX = ceil((tempPoint.x + abs(xlo))/bondMax);  // Possibly problematic if BBox lo extent is positive
                if(tempX == 0) tempX = 1;                    // Fixes case where vector point is also BBox lo value
            tempY = ceil((tempPoint.y + abs(ylo))/bondMax);
                if(tempY == 0) tempY = 1;
            tempZ = ceil((tempPoint.z + abs(zlo))/bondMax);
                if(tempZ == 0) tempZ = 1;

        address = ((tempX - 1)* (simpleSize)) + ((tempY - 1) * zCubes) + tempZ;  // The Magic Formula for Address Assignment

              curatomarray = addressNums[address];  // back up array for current address
              curatomarray += placeAtom;            // Add current atom ID to the temp addreess list
     
              addressNums[address] = curatomarray;  // Copy temp back to the Address Array

    }

//__________________________________Scan Cube and it's +1 Neighbors, add atoms to newlist, link______________

    moninit(maxAddress, "Generating Links"); 

    var linkList[atomIndex];

    for(doit=1; doit<=maxAddress; doit++){
   
        newlist = nil;
        newcount = 0;

        for(innerone = doit; innerone <= (doit + 1 ); ++innerone){ // Loop For Current, Current/Z+1
            if(innerone <= maxAddress){
                if(addressNums[innerone] != nil){        
                    for(i=1; i<=sizeof(addressNums[innerone]); i++){
                        ++newcount;
                        newlist[newcount] = addressNums[innerone,i];
                    }
                }
            }

                //For X+1, X+1/Z+1

                innertwo = (innerone + simpleSize);
                if(innertwo <= maxAddress){
                    if(addressNums[innertwo] != nil){        
                        for(i=1; i<=sizeof(addressNums[innertwo]); i++){
                            ++newcount;
                            newlist[newcount] = addressNums[innertwo,i];
                        }
                    }
                }

                //For Y+1/X+1, Y+1/X+1/Z+1

                innerthree = (innertwo + zCubes);
                if(innerthree <= maxAddress){
                    if(addressNums[innerthree] != nil){        
                        for(i=1; i<=sizeof(addressNums[innerthree]); i++){
                            ++newcount;
                            newlist[newcount] = addressNums[innerthree,i];
                        }
                    }
                }

                //For Y+1, Y+1/Z+1

                innerfour = (innerone + zCubes);
                if(innerfour <= maxAddress){
                    if(addressNums[innerfour] != nil){        
                        for(i=1; i<=sizeof(addressNums[innerfour]); i++){
                            ++newcount;
                            newlist[newcount] = addressNums[innerfour,i];
                        }
                    }
                }
        }

            newlist.sortA();
            newlist.reduce();

            if(monstep()) return;

            if(newlist.size() >= 2){  // If there are more than 2 atoms in the list, check them for bonds
        
                loopCap = sizeof(newlist);

                for(linkscan = 1; linkscan <= loopCap; linkscan++){
                
                    fromList = newlist[linkscan];
                    atomPrime = logarray[fromList];

                    for(innerloop = linkscan+1; innerloop <= loopCap; innerloop++){

                        secondList = newlist[innerloop];
                        atomSecond = logarray[secondList];

                        searchArray = searchParams(atomPrime,atomSecond);

                        p1 = vectorArray[fromList].asVec();
                        p2 = vectorArray[secondList].asVec();
        
                        dist = extent(p1,p2);
                        len = sqrt( dist.x * dist.x + dist.y * dist.y + dist.z * dist.z );

                        if(len <= (searchArray  * loosen) ){ // If link search is positive, add to unsorted results

                            linkTemp = linkList[fromList];
                            linkTemp += secondList;
                            linkList[fromList] = linkTemp;
                        }
                    }
                }
            }
        }  //  End of Assignment & Comparison 
        

        monend();

        // Finally, take the unsorted lists, sort them, and eliminate duplicate links

        moninit(atomIndex,"Create Link Geometry");

        for(finalLoop = 1; finalLoop <= atomIndex; ++finalLoop){

            eachList = linkList[finalLoop];
            eachList.sortA();
            eachList.reduce();
            eachCap = eachList.size();

            if(monstep()) return;

            for(eachLoop = 1; eachLoop <= eachCap; eachLoop++){  // Now make the actual geometry
        
                p1 = vectorArray[finalLoop].asVec();

                eachAtom = eachList[eachLoop];  
      
                p2 = vectorArray[eachAtom].asVec();

                if(pLinkResolution==1){

                    editbegin();
                        point[1] = addpoint(p1);
                        point[2] = addpoint(p2);
                        addpolygon(point);
                    editend();  
                    selhide(UNSELECTED);
                    selhide(SELECTED);

                }else{ // create a cylinder or a box

                    pnt[1] = p1;
                    pnt[2] = p2;
                    bondLen = addlink(pnt,radius,pLinkResolution,pDrawMode); 
                    // see addlink function at the end of the code
                } 
            }
        }


    



    monend();
    editend();
        lyrsetfg(98);
    selunhide();
        cut();
    lyrsetfg(fg);
        paste();
    }



//_______________________________Unhide All Geometry


selunhide();

    if(keeplog == 1) logFile.close();


} //  END OF MAIN EXECUTION



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  USER DEFINED FUNCTIONS
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



vis1: value { return (value==1); }
vis2: value { return (value==2); }
vis3: value { return (value==1 || value==2); }
vis4: value { return (value==5); }


limittess: value
{
    if(value<1) setvalue(e6,1);
    if(value>4) setvalue(e6,4);
}

limitseg: value
{
    if(value<3) setvalue(e62,4);
    if(value>32) setvalue(e62,32);
}


addlink: pnt,radius,sides,mode
{
    editend();

    current = lyrfg();

    p1 = pnt[1].asVec();
    p2 = pnt[2].asVec();
    
    dist = extent(p1,p2);
    len = sqrt( dist.x * dist.x + dist.y * dist.y + dist.z * dist.z );

    if(len>0){
    
        lyrsetfg(99);
        if(sides > 2){
            makedisc( radius, 0, len, Y, sides );
        }else{
            v1 = <-radius,-len/2,0>;
            v2 = <radius,len-len/2,0>;
            makebox(v1,v2);
        }
        
        xrot = 57.29578 * acos( dist.y / len );
        yrot = 90 + 57.29578 * atan2( dist.z / len , dist.x / len );
        
        move(<0,len/2,0>);
        rotate(xrot , X , <0,0,0>);
        rotate(yrot , Y , <0,0,0>);
        move(p1);
        
        // remove links extremity when atoms are drawn
        if(mode <= 3 && sides > 2){
            editbegin();
                lst = polygons;
            editend();
            selpolygon(CLEAR);
            selpolygon( SET, POLYID, lst[1] );
            selpolygon( SET, POLYID, lst[lst.count()]);
            delete();
        }
        
        cut();
        lyrsetfg(98);
        paste();

    selhide(UNSELECTED);
    selhide(SELECTED);

    }
    editbegin();

return len;
}


atan2: y,x
{
    if(y == 0){
        return x >= 0? 0: PI;
    }
    if(y > 0){
        return PI*.5-atan(x/y);
    } else {
        return -PI*.5-atan(x/y);
    }
}


protienid: acronym
{

    if(acronym == "
    ") return 1;

    if(acronym == "ALA") return 1;                         
    if(acronym == "ARG") return 2;                         
    if(acronym == "ASN") return 3;                         
    if(acronym == "ASP") return 4;                         
    if(acronym == "ASX") return 5;                         
    if(acronym == "CYS") return 6;                         
    if(acronym == "GLN") return 7;                         
    if(acronym == "GLU") return 8;                         
    if(acronym == "GLX") return 9;                         
    if(acronym == "GLY") return 10;                         
    if(acronym == "HIS") return 11;                         
    if(acronym == "ILE") return 12;                         
    if(acronym == "LEU") return 13;                         
    if(acronym == "LYS") return 14;                         
    if(acronym == "MET") return 15;                         
    if(acronym == "PHE") return 16;                         
    if(acronym == "PRO") return 17;                         
    if(acronym == "SER") return 18;                         
    if(acronym == "THR") return 19;                         
    if(acronym == "TRP") return 20;                         
    if(acronym == "TYR") return 21;                         
    if(acronym == "VAL") return 22;                         

    if(acronym == "A") return 1;
    if(acronym == "R") return 2;
    if(acronym == "N") return 3;
    if(acronym == "D") return 4;
    if(acronym == "B") return 5;
    if(acronym == "C") return 6;
    if(acronym == "Q") return 7;
    if(acronym == "E") return 8;
    if(acronym == "Z") return 9;
    if(acronym == "G") return 10;
    if(acronym == "H") return 11;
    if(acronym == "I") return 12;
    if(acronym == "L") return 13;
    if(acronym == "K") return 14;
    if(acronym == "M") return 15;
    if(acronym == "F") return 16;
    if(acronym == "P") return 17;
    if(acronym == "S") return 18;
    if(acronym == "T") return 19;
    if(acronym == "W") return 20;
    if(acronym == "Y") return 21;
    if(acronym == "V") return 22;

    if(acronym == "A") return 30;
    if(acronym == "+A") return 31;
    if(acronym == "C") return 32;
    if(acronym == "+C") return 33;
    if(acronym == "G") return 34;
    if(acronym == "+G") return 35;
    if(acronym == "I") return 36;
    if(acronym == "+I") return 37;
    if(acronym == "T") return 38;
    if(acronym == "+T") return 39;
    if(acronym == "U") return 40;
    if(acronym == "+U") return 41;

    if(acronym == "UNK") return 50;

return 50;

}


searchParams: atomPrime, atomSecond
{

// All Lengths are gathered empirically from a number of PDB files


    if(atomPrime == "C"){
        
        if(atomSecond =="C"){
            lenMax = 1.9292;
            return lenMax;
        }

        if(atomSecond =="H"){
            lenMax = 1.0930;
            return lenMax;
        }

        if(atomSecond =="N"){
            lenMax = 1.9282;
            return lenMax;
        }

        if(atomSecond =="O"){
            lenMax = 1.5095;
            return lenMax;
        }

        if(atomSecond =="Cl"){
            lenMax = 1.7973;
            return lenMax;
        }

        if(atomSecond =="S"){
            lenMax = 1.8222;
            return lenMax;
        }

        if(atomSecond =="I"){
            lenMax = 2.1457;
            return lenMax;
        }

        if(atomSecond =="F"){
            lenMax = 1.3919;
            return lenMax;
        }

        if(atomSecond =="Br"){
            lenMax = 1.9326;
            return lenMax;
        }

        if(atomSecond =="P"){
            lenMax = 1.8300;
            return lenMax;
        }

        lenMax = 2.1457;
        return lenMax;
    }
        
    if(atomPrime == "H"){
    
        if(atomSecond =="C"){
            lenMax = 1.0930;
            return lenMax;
        }
        if(atomSecond =="N"){
            lenMax = 1.0711;
            return lenMax;
        }
        if(atomSecond =="O"){
            lenMax = 1.0506;
            return lenMax;
        }

        lenMax = 1.0930;
        return lenMax;
    }
        
    if(atomPrime == "N"){
        
        if(atomSecond =="C"){
            lenMax = 1.9282;
            return lenMax;
        }
        if(atomSecond =="H"){
            lenMax = 1.0711;
            return lenMax;
        }
        if(atomSecond =="O"){
            lenMax = 1.4805;
            return lenMax;
        }
        if(atomSecond =="Fe"){
            lenMax = 1.8717;
            return lenMax;
        }
        if(atomSecond =="P"){
            lenMax = 1.8142;
            return lenMax;
        }

        lenMax = 1.9282;
        return lenMax;
    }
        
    if(atomPrime == "O"){
        
        if(atomSecond =="C"){
            lenMax = 1.5095;
            return lenMax;
        }
        if(atomSecond =="S"){
            lenMax = 1.7512;
            return lenMax;
        }
        if(atomSecond =="H"){
            lenMax = 1.0506;
            return lenMax;
        }
        if(atomSecond =="P"){
            lenMax = 1.7954;
            return lenMax;
        }
        if(atomSecond =="N"){
            lenMax = 1.4805;
            return lenMax;
        }

        if(atomSecond =="Na"){
            lenMax = 2.2854;
            return lenMax;
        }

        if(atomSecond =="K"){
            lenMax = 2.324;
            return lenMax;
        }

        lenMax = 1.7954;
        return lenMax;
    }
        
    if(atomPrime == "S"){
        
        if(atomSecond =="O"){
            lenMax = 1.7512;
            return lenMax;
        }
        if(atomSecond =="C"){
            lenMax = 1.8222;
            return lenMax;
        }
        if(atomSecond =="P"){
            lenMax = 2.0813;
            return lenMax;
        }
        if(atomSecond =="S"){
            lenMax = 2.0399;
            return lenMax;
        }

        lenMax = 2.0813;
        return lenMax;
    }
        
    if(atomPrime == "Cl"){
        
        if(atomSecond =="C"){
            lenMax = 1.7973;
            return lenMax;
        }

        lenMax = 1.7973;
        return lenMax;
    }
        
    if(atomPrime == "P"){
    
        if(atomSecond =="O"){
            lenMax = 1.7954;
            return lenMax;
        }
        if(atomSecond =="S"){
            lenMax = 2.0813;
            return lenMax;
        }
        if(atomSecond =="C"){
            lenMax = 1.8300;
            return lenMax;
        }
        if(atomSecond =="F"){
            lenMax = 1.7790;
            return lenMax;
        }
        if(atomSecond =="N"){
            lenMax = 1.8142;
            return lenMax;
        }

        lenMax = 2.0813;
        return lenMax;
    }
        
    if(atomPrime == "I"){
        
        if(atomSecond =="C"){
            lenMax = 2.1457;
            return lenMax;
        }

        lenMax = 2.1457;
        return lenMax;
    }
        
    if(atomPrime == "F"){
        
        if(atomSecond =="C"){
            lenMax = 1.3919;
            return lenMax;
        }
        if(atomSecond =="P"){
            lenMax = 1.7790;
            return lenMax;
        }

        lenMax = 1.7790;
        return lenMax;
    }
        
    if(atomPrime == "Br"){
        
        if(atomSecond =="C"){
            lenMax = 1.9326;
            return lenMax;
        }

        lenMax = 1.9326;
        return lenMax;
    }
        
    if(atomPrime == "Fe"){
        
        if(atomSecond =="N"){
            lenMax = 1.8717;
            return lenMax;
        }

        lenMax = 1.8717;
        return lenMax;
    }

    if(atomPrime == "Na"){
        
        if(atomSecond =="O"){
            lenMax = 2.2854;
            return lenMax;
        }

        lenMax = 3.0964;
        return lenMax;
    }

    if(atomPrime == "K"){  // Small Sample...Measured from best connection guess in Modeler
        
        if(atomSecond =="O"){
            lenMax = 2.324;
            return lenMax;
        }

        lenMax = 2.324;
        return lenMax;
    }

info("Unknown Pair for Compairison: ",atomPrime,atomSecond);
        lenMax = 2.1457;
        return lenMax;

}
